// Module: Color Changing Applicate
// Description: A application that changes the color of the boxes based on click state
// Author:Jimmy T.
// Date: 00/01/16
// version: 1.0

(function(colorWidget, $, undefined) {
	"use strict";
	/* You should not modify the code below */
	var myApp = angular.module('myApp', []);
	myApp.controller('MyCtrl', function MyCtrl($scope) {
		$scope.formModel = {
			color: '#00ff00'
		};
		$scope.reset = function(color) {
			$scope.formModel.color = color || null;
		};
	});
	/* You should not modify the code above*/
	/* Add your code below */






	/*/////////////// 
	 */ // version 2 controller
	/// using ng click with unique button functions for each box (statics boxs and buttons) 
	myApp.controller('colorWidget2Controller', function($scope) {
		$scope.formModel = {
			color: '#00ff00'
		};
		$scope.newClass = 'green';
		$scope.btnReset = function(color) { // resets label boxes on ng-click
			$('.colored-boxes-2 label').removeClass('active'); 			
			$('.btn-cntrl-2 button').removeClass('active');
			$scope.formModel.color = color || null;
		};
		$scope.btnRed = function(color) { // selects red box on ng-click
			$('.colored-boxes-2 label, .btn-cntrl-2 button').removeClass('active'); // removes classes on all labels and btn
			$('.colored-boxes-2 label:nth-child(1), .btn-cntrl-2 button:nth-child(1)').addClass('active'); //addes active to current selected item
			$scope.formModel.color = color || null; // shows color hex code
			$scope.newClass = 'red'; // calls color class for hex code
		};
		$scope.btnGreen = function(color) { // selects green box on ng-click
			$('.colored-boxes-2 label, .btn-cntrl-2 button').removeClass('active');
			$('.colored-boxes-2 label:nth-child(2), .btn-cntrl-2 button:nth-child(2)').addClass('active');
			$scope.formModel.color = color || null;
			$scope.newClass = 'green';
		};
		$scope.btnBlue = function(color) { // selects blue box on ng-click
			$('.colored-boxes-2 label, .btn-cntrl-2 button').removeClass('active');
			$('.colored-boxes-2 label:nth-child(3), .btn-cntrl-2 button:nth-child(3)').addClass('active');
			$scope.formModel.color = color || null;
			$scope.newClass = 'blue';
			$scope.boxHeightThree = $('.colored-boxes-2 label:nth-child(3)').height();
		};
	}); // end version 2 controller






	/*/////////////// 
	 */ // version 3 controller
	/// version 3 using ng-repeat and data arrays (dynamically boxes and content)	
	myApp.controller('colorWidget3Controller', function($scope) {
		// box variables data array
		$scope.boxlists = [{
			name: 'Red', // name of label box
			colorcode: '#ff0000', // color code hex 
			boxnumber: '1', // label number for nth-child
			activeOrder: '', // sets first active class to box green is current first active
			colorclass: 'red' // sets class of red
		}, {
			name: 'Green',
			colorcode: '#00ff00',
			boxnumber: '2',
			activeOrder: 'active',
			colorclass: 'green'
		}, {
			name: 'Blue',
			colorcode: '#0000ff',
			boxnumber: '3',
			activeOrder: '',
			colorclass: 'blue'
		}];
		// button variables data array
		$scope.buttonlists = [{
			name: 'Set Red', // button name
			colorcode: '#ff0000', // button color hex code
			boxnumber: '1', // button number for nth-child
			activeOrder: '', // active order
			colorclass: 'red' // color class for hex color 
		}, {
			name: 'Set Green',
			colorcode: '#00ff00',
			boxnumber: '2',
			activeOrder: 'active',
			colorclass: 'green'
		}, {
			name: 'Set Blue',
			colorcode: '#0000ff',
			boxnumber: '3',
			activeOrder: '',
			colorclass: 'blue'
		}, {
			name: 'Reset',
			colorcode: '',
			boxnumber: '0',
			activeOrder: '',
			colorclass: ''
		}];
		// sets values for start color code and class for first active state
		$scope.formModel = {
			color: '#00ff00', // sets the first color hex 
			classcolor: 'green' // sets the first active class 
		};
		$scope.newClass = 'green'; // sets the first active class 		
		$scope.boxSize = {
			width: $('.colored-boxes label').width() + 'px', // calls element label width and concatenate px to the end
			height: $('.colored-boxes label').height() + 'px' // calls element label height and concatenate px to the end					
		};
		$scope.btnBox = function(color, boxNum, classcolor) {
			var activeClass = 'active'; // sets activeClass var to active class
			$('.btn-cntrl-3 button, .colored-boxes-3 label').removeClass(activeClass); // removes active class to selected button and label
			$('.btn-cntrl-3 button:nth-child(' + boxNum + '), .colored-boxes-3 label:nth-child(' + boxNum + ')').addClass(activeClass); // adds active class to selected button and label 			
			$scope.formModel.color = color || null; // shows color hex code
			$scope.formModel.classcolor = classcolor || null; // calls class for hex code
		};
	}); //end version 3 widget






	// calls the year in footer
	myApp.controller('datCtrl', function($scope) {
		$scope.today = new Date();
	});// end year







	/*/////////////// 
	 */ // Directives
	/// Directives to include widget versions 2 and 3 from the views folder
	angular.module('myApp')
		.directive('colorWidgetTwo', function() { // directive for color widget version 2
			return {
				templateUrl: "views/color-widget-two.html", // includes color widgets version 2 from the views folder
				restrict: "A", // restriction for attributes
			};
		})
		.directive('colorWidgetThree', function() { // directive for color widget version 3
			return {
				templateUrl: "views/color-widget-three.html", // includes color widgets version 3 from the views folder
				restrict: "E", // restriction for Element
			};
		});






	/*/////////////// 
	 */ // version 1 controller
	/// version 1 using jquery

	var init = {
		/*/////////////// 
		 */ // button indicator function
		buttonStatusIndicator: function(buttonGroup) {
			$(buttonGroup + ' ' + ' ' + 'button').on('click', function() {
				$(buttonGroup + ' ' + ' ' + 'button').removeClass('active');
				$(this).addClass('active');
			});
		},
		/*/////////////// 
		 */ // Label color change function		
		clickColorChange: function() {
			var coloredBoxes = $('.colored-boxes label'); // colored boxes selector
			var activeState = 'active'; // class name for active state
			coloredBoxes.on('click', function() {
				coloredBoxes.removeClass(activeState);
				$(this).addClass(activeState);
			});
		},
		/*/////////////// 
		 */ // button controller function
		buttonControls: function() {
			var btnRed = $('.btn-red'); // class for red button highliter
			var btnGreen = $('.btn-green'); // class for green button highliter
			var btnBlue = $('.btn-blue'); // class for blue button highliter
			var activeState = 'active'; // class name for active state			
			var coloredBoxes = $('.colored-boxes label'); // colored boxes selector
			var btnCntrl = $('.btn-cntrl button');
			var btnReset = $('.btn-reset');
			var boxRed = $('.colored-boxes label:nth-child(1)');
			var boxGreen = $('.colored-boxes label:nth-child(2)');
			var boxBlue = $('.colored-boxes label:nth-child(3)');

			function resetBoxes() {
				coloredBoxes.removeClass(activeState);
			}
			btnCntrl.on('click ', function() {
				resetBoxes();
			});
			btnReset.on('click', function() {
				resetBoxes();
			});
			//button red controls
			btnRed.on('click', function() {
				boxRed.addClass(activeState);
			});
			//button green controls
			btnGreen.on('click', function() {
				boxGreen.addClass(activeState);
			});
			//button blue controls
			btnBlue.on('click', function() {
				boxBlue.addClass(activeState);
			});
		}
	};

	$(document).ready(function() {
		//**********************         
		// Initialize Functions
		//**********************                                              
		//init.buttonStatusIndicator('.btn-cntrl');	
		init.clickColorChange(); // calls  color change function		
		init.buttonControls(); // calls buttons controls	  			
	});


}(window.colorWidget = window.colorWidget || {}, jQuery));
// end of anon function